use maud::{Markup, Render, html};

use super::UIWidget;

#[allow(non_snake_case)]
pub fn Header<T: UIWidget + 'static>(inner: T) -> HeaderWidget {
    HeaderWidget(Box::new(inner))
}

pub struct HeaderWidget(Box<dyn UIWidget>);

impl Render for HeaderWidget {
    fn render(&self) -> Markup {
        self.render_with_class("")
    }
}

impl UIWidget for HeaderWidget {
    fn can_inherit(&self) -> bool {
        true
    }

    fn render_with_class(&self, class: &str) -> Markup {
        html! {
            header class=(class) {
                (self.0.as_ref())
            }
        }
    }
}
